"use strict";
(self["webpackChunktvb_ext_unicore"] = self["webpackChunktvb_ext_unicore"] || []).push([["lib_index_js"],{

/***/ "./lib/components/CheckBoxToggle.js":
/*!******************************************!*\
  !*** ./lib/components/CheckBoxToggle.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CheckBoxToggle: () => (/* binding */ CheckBoxToggle)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

function CheckBoxToggle({ onToggle, initialCheckedState, label }) {
    const [value, setValue] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(initialCheckedState);
    const handleChange = (ev) => {
        setValue(ev.target.checked);
        onToggle(ev.target.checked);
    };
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("input", { id: 'auto-refresh', type: 'checkbox', checked: value, onChange: handleChange }),
        label && react__WEBPACK_IMPORTED_MODULE_0___default().createElement("label", { htmlFor: 'auto-refresh' }, label)));
}


/***/ }),

/***/ "./lib/components/JobOutputFiles.js":
/*!******************************************!*\
  !*** ./lib/components/JobOutputFiles.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JobOutput: () => (/* binding */ JobOutput),
/* harmony export */   JobOutputFiles: () => (/* binding */ JobOutputFiles),
/* harmony export */   ProgressBar: () => (/* binding */ ProgressBar)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _handler__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../handler */ "./lib/handler.js");
/* harmony import */ var _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/dragdrop */ "webpack/sharing/consume/default/@lumino/dragdrop");
/* harmony import */ var _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @lumino/algorithm */ "webpack/sharing/consume/default/@lumino/algorithm");
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_lumino_algorithm__WEBPACK_IMPORTED_MODULE_4__);







const JobOutputFiles = (props) => {
    const [outputFiles, setOutputFiles] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(null);
    const [message, setMessage] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)('');
    // use effect to load job outputs
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        // encode url for safe passing as param
        const url = encodeURIComponent(props.job_url);
        //fetch output files
        (0,_handler__WEBPACK_IMPORTED_MODULE_5__.requestAPI)(`job_output?job_url=${url}`)
            .then(resp => setOutputFiles(resp))
            .catch(err => {
            console.log('err: ', err);
            setMessage(err.message);
        });
    }, []);
    function waitingOrFailed() {
        return message ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("p", { className: 'unicoreMessage' }, message)) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'loadingRoot' },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: 'unicoreLoading' })));
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("tr", { className: 'outputFiles', "data-testid": `output-${props.job_url}` }, outputFiles ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", { colSpan: 100 },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("p", { className: 'unicoreMessage' }, message),
        "Output Files:",
        Object.entries(outputFiles).map(([output, outputType]) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(JobOutput, { output: output, outputType: outputType, key: `${output}`, jobUrl: props.job_url, jobId: props.jobId, getFileBrowser: props.getFileBrowser, getKernel: props.getKernel }))))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", { colSpan: 100 }, waitingOrFailed()))));
};
const JobOutput = (props) => {
    const { output, outputType, jobUrl, getFileBrowser, jobId } = props;
    const [downloading, setDownloading] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const downloadStatus = {
        success: 'unicoreMessage-success',
        warning: 'unicoreMessage-warning',
        error: 'unicoreMessage'
    };
    const [message, setMessage] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)({
        text: '',
        className: downloadStatus.success
    });
    let drag;
    /**
     * function to download a file to the current path (directory) opened in filebrowser
     * @param file - name of the file to be downloaded from this jobs working dir
     */
    async function downloadToCurrentPath(file) {
        file = file.replace('/', '');
        let downloadedFileName = file;
        if (['stdout', 'stderr', 'UNICORE_SCRIPT_EXIT_CODE'].includes(downloadedFileName)) {
            downloadedFileName = `${file}_${jobId}`;
        }
        if (fileExists(downloadedFileName) &&
            !(await confirmReDownload(downloadedFileName))) {
            return;
        }
        const browser = getFileBrowser();
        const path = browser.model.path;
        console.log('File browser path: ', path);
        const dataToSend = {
            job_url: jobUrl,
            in_file: file,
            path: path,
            out_file: downloadedFileName
        };
        try {
            setDownloading(true);
            const response = await (0,_handler__WEBPACK_IMPORTED_MODULE_5__.requestAPI)(`drive/${encodeURIComponent(jobUrl)}/${file}`, {
                method: 'POST',
                body: JSON.stringify(dataToSend)
            });
            console.log('response: ', response);
            setMessage({
                text: response.message,
                className: downloadStatus[response.status]
            });
            setDownloading(false);
            browser.update();
        }
        catch (e) {
            await (0,_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3__.showErrorMessage)('Error on request:', e);
            const errorMessage = e instanceof Error ? e.message : 'An unexpected error occurred';
            setMessage({
                text: errorMessage,
                className: downloadStatus.error
            });
            setDownloading(false);
        }
    }
    function fileExists(downloadedFileName) {
        const browser = getFileBrowser();
        const items = browser.model.items();
        return (0,_lumino_algorithm__WEBPACK_IMPORTED_MODULE_4__.some)(items, (item, _index) => item.name === downloadedFileName);
    }
    async function confirmReDownload(downloadedFileName) {
        const confirm = await (0,_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3__.showDialog)({
            title: 'File already exists!',
            body: `If you continue the file ${downloadedFileName}} will be re downloaded and overwritten!`,
            buttons: [
                _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3__.Dialog.cancelButton({ label: 'Cancel' }),
                _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_3__.Dialog.okButton({ label: 'Continue' })
            ]
        });
        return confirm.button.accept;
    }
    async function handleDropToFileBrowser(_event) {
        await downloadToCurrentPath(output);
        removeDropHandlerFromFileBrowser();
    }
    function addDropHandlerToFileBrowser() {
        const browser = getFileBrowser();
        browser.node.addEventListener('drop', handleDropToFileBrowser);
    }
    function removeDropHandlerFromFileBrowser() {
        const browser = getFileBrowser();
        browser.node.removeEventListener('drop', handleDropToFileBrowser);
        drag === null || drag === void 0 ? void 0 : drag.dispose();
    }
    /**
     * instantiate and start the Drag event with the cell and code to be injected
     * @param event
     */
    async function handleDragStart(event) {
        // make sure we have a kernel that can handle python code
        addDropHandlerToFileBrowser();
        const code = (0,_constants__WEBPACK_IMPORTED_MODULE_6__.getDownloadFileCode)(jobUrl, output);
        drag = new _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__.Drag({
            mimeData: new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__.MimeData(),
            supportedActions: 'copy',
            proposedAction: 'copy',
            source: output
        });
        // set data for copy in an existing cell
        drag.mimeData.setData(_constants__WEBPACK_IMPORTED_MODULE_6__.TEXT_PLAIN_MIME, code);
        drag.start(event.clientX, event.clientY).then(r => {
            console.log('r: ', r);
            // remove handler after drop in cell to avoid download when dropping a job
            removeDropHandlerFromFileBrowser();
        });
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'unicore-jobOutput', "data-testid": `output-${output}` },
        outputType.is_file ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("i", { className: 'fa fa-file' })) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("i", { className: 'fas fa-folder' })),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("p", { draggable: true, className: 'outputFileName', onDragStart: handleDragStart }, output),
        outputType && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: message.className }, message.text),
            downloading ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'loadingRoot' },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: 'unicoreLoading' }))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("i", { "data-testid": 'download-file', className: 'fa fa-download clickableIcon', onClick: () => downloadToCurrentPath(output), onKeyDown: event => {
                    if (event.key === 'Enter') {
                        downloadToCurrentPath(output);
                    }
                }, tabIndex: 0 }))))));
};
// to use when downloading file and add style
const ProgressBar = (props) => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { style: { width: `${props.size}rem` }, className: 'unicore-progressBar', "data-testid": 'progress-bar' },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { style: { width: `${props.done}%` } })));
};


/***/ }),

/***/ "./lib/components/ModalComponent.js":
/*!******************************************!*\
  !*** ./lib/components/ModalComponent.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ModalType: () => (/* binding */ ModalType),
/* harmony export */   ModalWidget: () => (/* binding */ ModalWidget)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

/**
 * enum to describe possible modals
 */
var ModalType;
(function (ModalType) {
    ModalType["Warning"] = "WARNING";
    ModalType["Error"] = "ERROR";
    ModalType["Success"] = "SUCCESS";
    ModalType["Confirm"] = "CONFIRM";
})(ModalType || (ModalType = {}));
/**
 * Widget to display a modal on screen
 */
const ModalWidget = (props) => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'unicoreModal', style: { display: props.visible ? 'flex' : 'none' }, "data-testid": 'modal-widget' },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("h3", null, props.modalType)),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("p", null, String(props.message))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("button", { onClick: () => props.setVisible(false) }, "CLOSE")))));
};


/***/ }),

/***/ "./lib/components/PaginationComponent.js":
/*!***********************************************!*\
  !*** ./lib/components/PaginationComponent.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PaginationComponent: () => (/* binding */ PaginationComponent)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

const PaginationComponent = (props) => {
    function handleNextPage() {
        props.setPageState(props.currentPage + 1);
    }
    function handlePreviousPage() {
        props.setPageState(props.currentPage - 1);
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'unicorePagination', "data-testid": 'pagination-component' },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'btnLeftContainer' }, props.showPrevButton && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("button", { onClick: handlePreviousPage, "data-testid": 'p-btn-left' },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("i", { className: 'fa fa-arrow-left' })))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'currentPageContainer' },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", null, `Page: ${props.currentPage}`)),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'btnRightContainer' }, props.showNextButton && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("button", { onClick: handleNextPage, "data-testid": 'p-btn-right' },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("i", { className: 'fa fa-arrow-right' })))))));
};


/***/ }),

/***/ "./lib/components/SideButton.js":
/*!**************************************!*\
  !*** ./lib/components/SideButton.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SideButton: () => (/* binding */ SideButton)
/* harmony export */ });
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/dragdrop */ "webpack/sharing/consume/default/@lumino/dragdrop");
/* harmony import */ var _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__);


/**
 * A customizable button to be added in left or right sidebars of the LabShell.
 * When clicked, this button will execute the command given in the constructor and will collapse any other
 * opened sidebar.
 */
class SideButton extends _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.Widget {
    constructor(options) {
        super(options);
        this._labShell = options.labShell;
        this._command = options.command;
        this._commands = options.commandRegistry;
        this._area = options.area;
        this._shellOptions = options.shellOptions;
        this.title.icon = options.icon;
        this.title.caption = options.caption;
        this.id = options.id ? options.id : 'tvb-ext-unicore-side-btn';
        this.title.className = this.id;
    }
    /**
     * Method to be called after instantiating this button in order for it to be added in the sidebar.
     */
    addToLabShell() {
        this._labShell.add(this, this._area, this._shellOptions);
    }
    /**
     * When a show message is received by button it changes the cursor aspect
     * while waiting for the command to be executed then changes it back to normal
     * @param msg
     * @protected
     */
    async onAfterShow(msg) {
        console.log('after show');
        super.onAfterShow(msg);
        const cursorOverride = _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__.Drag.overrideCursor('wait');
        await this._click();
        cursorOverride.dispose();
    }
    /**
     * Collapse the sidebar corresponding to the area in which the button is placed then
     * execute the command received in the constructor if it exists in the command registry
     * @private
     */
    async _click() {
        switch (this._area) {
            case 'left':
                this._labShell.collapseLeft();
                break;
            case 'right':
                this._labShell.collapseRight();
                break;
            default:
                break;
        }
        await this._commands.execute(this._command);
    }
}


/***/ }),

/***/ "./lib/components/UnicoreJobsTable.js":
/*!********************************************!*\
  !*** ./lib/components/UnicoreJobsTable.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JobRow: () => (/* binding */ JobRow),
/* harmony export */   TableBody: () => (/* binding */ TableBody),
/* harmony export */   TableHeader: () => (/* binding */ TableHeader),
/* harmony export */   UnicoreJobsTable: () => (/* binding */ UnicoreJobsTable)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/dragdrop */ "webpack/sharing/consume/default/@lumino/dragdrop");
/* harmony import */ var _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _JobOutputFiles__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./JobOutputFiles */ "./lib/components/JobOutputFiles.js");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");





const UnicoreJobsTable = (props) => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("table", null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(TableHeader, { columns: props.columns }),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(TableBody, { buttonSettings: props.buttonSettings, columns: props.columns, data: props.data, setMessageState: props.setMessageState, getKernel: props.getKernel, getJob: props.getJob, handleError: props.handleError, getFileBrowser: props.getFileBrowser, afterButtonSettingClick: props.afterButtonSettingClick })));
};
const TableHeader = (props) => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("thead", null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("tr", null,
            props.columns.map(colName => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", { key: colName, className: colName }, colName.toUpperCase()))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", null, "ACTIONS"))));
};
const TableBody = (props) => {
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("tbody", null, props.data.map(job => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(JobRow, { key: job.id, id: job.id, cols: props.columns, job: job, buttonSettings: props.buttonSettings, setMessageState: props.setMessageState, getKernel: props.getKernel, getJob: props.getJob, handleError: props.handleError, getFileBrowser: props.getFileBrowser, afterButtonSettingClick: props.afterButtonSettingClick })))));
};
const JobRow = (props) => {
    const [loading, setLoading] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    const [logsVisible, setLogsVisible] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    function handleButton(ev) {
        ev.stopPropagation(); // stop event to avoid opening the logs
        setLoading(true);
        props.buttonSettings
            .onClick(...props.buttonSettings.onClickFieldArgs.map(field => props.job[field]))
            .then(r => {
            props.afterButtonSettingClick().then(() => setLoading(false));
            props.setMessageState(r.message);
        });
    }
    /**
     * instantiate and start the Drag event with the cell and code to be injected
     * @param event
     */
    async function handleDragStart(event) {
        var _a;
        // make sure we have a kernel that can handle python code
        const kernel = await props.getKernel();
        if (!kernel) {
            // show error modal
            props.handleError("Current kernel can't be used to handle this operation!");
            return;
        }
        const code = props.getJob(props.job.resource_url);
        const drag = new _lumino_dragdrop__WEBPACK_IMPORTED_MODULE_1__.Drag({
            mimeData: new _lumino_coreutils__WEBPACK_IMPORTED_MODULE_2__.MimeData(),
            supportedActions: 'copy',
            proposedAction: 'copy',
            dragImage: (_a = document
                .getElementById(`${props.job.id}`)) === null || _a === void 0 ? void 0 : _a.cloneNode(true),
            source: props.job
        });
        // set data for copy in an existing cell
        drag.mimeData.setData(_constants__WEBPACK_IMPORTED_MODULE_3__.TEXT_PLAIN_MIME, code);
        drag.start(event.clientX, event.clientY).then(r => console.log('r: ', r));
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("tr", { onClick: () => setLogsVisible(!logsVisible), draggable: 'true', onDragStart: handleDragStart, "data-testid": `table-row-${props.job.id}` },
            props.cols.map((col, index) => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", { key: `${props.job.id}-${index}` }, props.job[col]))),
            loading ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", null,
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'loadingRoot' },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: 'unicoreLoading' })))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", null, props.job.is_cancelable && !loading && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("button", { onClick: handleButton }, "Cancel Job"))))),
        logsVisible && (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_JobOutputFiles__WEBPACK_IMPORTED_MODULE_4__.JobOutputFiles, { job_url: props.job.resource_url, getFileBrowser: props.getFileBrowser, getKernel: props.getKernel, jobId: props.job.id }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("tr", { className: 'detailsRow' },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement("td", { colSpan: 100 },
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement("textarea", { value: props.job.logs.join('\n'), readOnly: true })))))));
};


/***/ }),

/***/ "./lib/components/UnicoreSites.js":
/*!****************************************!*\
  !*** ./lib/components/UnicoreSites.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   UnicoreSites: () => (/* binding */ UnicoreSites)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _CheckBoxToggle__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./CheckBoxToggle */ "./lib/components/CheckBoxToggle.js");


/**
 * select component
 * @param props
 * @constructor
 */
const UnicoreSites = (props) => {
    /**
     * function to handle the change of selected option - meant to call the handler from props with
     * the new option value as param
     * @param event
     */
    function handleSiteChange(event) {
        props.onChangeSite(event.target.value);
    }
    const [spin, setSpin] = (0,react__WEBPACK_IMPORTED_MODULE_0__.useState)(false);
    function doSpin() {
        setSpin(true);
        setTimeout(() => setSpin(false), 500);
    }
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'pyunicoreSites', "data-testid": 'pyunicore-sites' },
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", null, "SITE:"),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("select", { onChange: handleSiteChange, disabled: props.disableSelection, "data-testid": 'select', defaultValue: props.defaultSite }, props.sites.map(site => (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("option", { key: site, id: site, value: site }, site))))),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("button", { className: `refreshBtn ${spin && 'spin'}`, onClick: () => {
                doSpin();
                props.refreshSite();
            }, disabled: props.loading },
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("i", { className: "fa fa-refresh" })),
        react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_CheckBoxToggle__WEBPACK_IMPORTED_MODULE_1__.CheckBoxToggle, { onToggle: props.setAutoReload, initialCheckedState: true, label: 'Auto refresh' })));
};


/***/ }),

/***/ "./lib/constants.js":
/*!**************************!*\
  !*** ./lib/constants.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   NO_SITE: () => (/* binding */ NO_SITE),
/* harmony export */   RELOAD_CHECK_RATE_MS: () => (/* binding */ RELOAD_CHECK_RATE_MS),
/* harmony export */   RELOAD_RATE_MS: () => (/* binding */ RELOAD_RATE_MS),
/* harmony export */   TEXT_PLAIN_MIME: () => (/* binding */ TEXT_PLAIN_MIME),
/* harmony export */   getDownloadFileCode: () => (/* binding */ getDownloadFileCode),
/* harmony export */   getJobCode: () => (/* binding */ getJobCode)
/* harmony export */ });
/**
 * this file was created to avoid imports from index.ts in tests which would
 * require mocking multiple external modules due to the way how imports work
 */
/**
 * represents the option in dropdown when no site is selected
 */
const NO_SITE = 'NONE';
/**
 * mime type for text data (usually attached to a Drag object)
 */
const TEXT_PLAIN_MIME = 'text/plain';
/**
 * How often should the component reload jobs expressed in milliseconds
 */
const RELOAD_RATE_MS = 60000;
/**
 * How often should the component check if RELOAD_RATE_MS have passed since the last update
 */
const RELOAD_CHECK_RATE_MS = 10000; //should check every 10sec
/**
 * function that generates the code for downloading a job output file -
 * code to be injected in a notebook cell
 * @param job_url
 * @param file
 */
function getDownloadFileCode(job_url, file) {
    return `from tvbextunicore.unicore_wrapper import unicore_wrapper
unicore = unicore_wrapper.UnicoreWrapper()
download_result = unicore.download_file('${job_url}', '${file}')
download_result`;
}
/**
 * function to generate the code to get a job - code to be injected in a notebook cell
 * @param job_url
 */
function getJobCode(job_url) {
    return `from tvbextunicore.unicore_wrapper import unicore_wrapper
unicore = unicore_wrapper.UnicoreWrapper()
job = unicore.get_job('${job_url}')
job`;
}


/***/ }),

/***/ "./lib/handler.js":
/*!************************!*\
  !*** ./lib/handler.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   requestAPI: () => (/* binding */ requestAPI),
/* harmony export */   requestStream: () => (/* binding */ requestStream)
/* harmony export */ });
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__);


/**
 * Call the API extension
 *
 * @param endPoint API REST end point for the extension
 * @param init Initial values for the request
 * @returns The response body interpreted as JSON
 */
async function requestAPI(endPoint = '', init = {}) {
    // Make request to Jupyter API
    const settings = _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.makeSettings();
    const requestUrl = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(settings.baseUrl, 'tvbextunicore', // API Namespace
    endPoint);
    let response;
    console.log('req URL: ', requestUrl);
    try {
        response = await _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.makeRequest(requestUrl, init, settings);
    }
    catch (error) {
        throw new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.NetworkError(error);
    }
    let data = await response.text();
    if (data.length > 0) {
        try {
            data = JSON.parse(data);
        }
        catch (error) {
            console.log('Not a JSON response body.', response);
        }
    }
    if (!response.ok) {
        throw new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.ResponseError(response, data.message || data);
    }
    return data;
}
/**
 * Call the API extension
 *
 * @param endPoint API REST end point for the extension
 * @param init Initial values for the request
 * @returns The response body interpreted as BLOB
 */
async function requestStream(endPoint = '', init = {}) {
    // Make request to Jupyter API
    const settings = _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.makeSettings();
    const requestUrl = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(settings.baseUrl, 'tvbextunicore', // API Namespace
    endPoint);
    let response;
    try {
        response = await _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.makeRequest(requestUrl, init, settings);
    }
    catch (error) {
        throw new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.NetworkError(error);
    }
    if (!response.ok) {
        const jsonData = await response.json();
        throw new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.ResponseError(response, jsonData.message || jsonData);
    }
    const data = await response.blob();
    return data;
}


/***/ }),

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/application */ "webpack/sharing/consume/default/@jupyterlab/application");
/* harmony import */ var _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./utils */ "./lib/utils.js");
/* harmony import */ var _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/filebrowser */ "webpack/sharing/consume/default/@jupyterlab/filebrowser");
/* harmony import */ var _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _pyunicoreWidget__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./pyunicoreWidget */ "./lib/pyunicoreWidget.js");
/* harmony import */ var _handler__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./handler */ "./lib/handler.js");
/* harmony import */ var _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/console */ "webpack/sharing/consume/default/@jupyterlab/console");
/* harmony import */ var _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./constants */ "./lib/constants.js");
/* harmony import */ var _style_icons_logo_unicore_svg__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ../style/icons/logo-unicore.svg */ "./style/icons/logo-unicore.svg");
/* harmony import */ var _components_SideButton__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./components/SideButton */ "./lib/components/SideButton.js");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5__);









// @ts-ignore



async function cancelJob(resource_url) {
    const dataToSend = { resource_url: resource_url };
    return (0,_handler__WEBPACK_IMPORTED_MODULE_6__.requestAPI)('jobs', {
        method: 'POST',
        body: JSON.stringify(dataToSend)
    });
}
/**
 * Initialization data for the tvb-ext-unicore extension.
 */
const plugin = {
    id: 'tvbextunicore:plugin',
    autoStart: true,
    requires: [
        _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__.ICommandPalette,
        _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__.ILayoutRestorer,
        _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__.IConsoleTracker,
        _jupyterlab_application__WEBPACK_IMPORTED_MODULE_0__.ILabShell,
        _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_3__.INotebookTracker,
        _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_2__.IFileBrowserFactory
    ],
    activate: async (app, palette, restorer, consoleTracker, labShell, notebookTracker, factory) => {
        console.log('JupyterLab extension tvb-ext-unicore is activated!');
        let widget;
        const columns = ['id', 'name', 'owner', 'site', 'status', 'start_time'];
        const command = 'tvbextunicore:open';
        app.commands.addCommand(command, {
            label: 'PyUnicore Task Stream',
            execute: async (args = { defaultSite: _constants__WEBPACK_IMPORTED_MODULE_7__.NO_SITE }) => {
                if (!widget || widget.isDisposed) {
                    let sitesResponse;
                    let availableSites = [];
                    let defaultSite;
                    try {
                        sitesResponse = await (0,_handler__WEBPACK_IMPORTED_MODULE_6__.requestAPI)('sites');
                        availableSites = [...Object.keys(sitesResponse.sites)];
                        const desiredDefaultSite = args['defaultSite'];
                        defaultSite = (0,_utils__WEBPACK_IMPORTED_MODULE_8__.validateDefaultSite)(desiredDefaultSite, availableSites);
                    }
                    catch (e) {
                        await (0,_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__.showErrorMessage)('ERROR', 'Unicore seems to be down at the moment. Please check service availability and try again later.');
                        return;
                    }
                    const content = new _pyunicoreWidget__WEBPACK_IMPORTED_MODULE_9__.PyunicoreWidget({
                        tableFormat: {
                            cols: columns,
                            idField: 'id',
                            buttonRenderConditionField: 'is_cancelable'
                        },
                        data: { message: sitesResponse.message, jobs: [] },
                        buttonSettings: {
                            onClick: cancelJob,
                            onClickFieldArgs: ['resource_url'],
                            isAsync: false,
                            name: 'Cancel Job'
                        },
                        sites: [_constants__WEBPACK_IMPORTED_MODULE_7__.NO_SITE, ...availableSites],
                        defaultSite: defaultSite,
                        reloadRate: 60000,
                        getKernel: async () => {
                            const kernel = Private.getCurrentKernel(labShell, notebookTracker, consoleTracker);
                            return (await Private.shouldUseKernel(kernel)) ? kernel : null; // make sure kernel is usable
                        },
                        getJobCode: _constants__WEBPACK_IMPORTED_MODULE_7__.getJobCode,
                        getFileBrowser: () => Private.getFileBrowser(factory)
                    });
                    widget = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__.MainAreaWidget({ content });
                    widget.id = 'tvbextunicore';
                    widget.title.label = 'PyUnicore Task Stream';
                    widget.title.closable = true;
                }
                if (!tracker.has(widget)) {
                    //Track the state of the widget for later restore
                    tracker.add(widget);
                }
                if (!widget.isAttached) {
                    app.shell.add(widget, 'main');
                }
                app.shell.activateById(widget.id);
            }
        });
        palette.addItem({ command, category: 'PyUnicore' });
        const tracker = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__.WidgetTracker({
            namespace: 'pyunicore'
        });
        const unicoreIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5__.LabIcon({
            name: 'unicoreIcon',
            svgstr: _style_icons_logo_unicore_svg__WEBPACK_IMPORTED_MODULE_10__
        });
        const sideBtn = new _components_SideButton__WEBPACK_IMPORTED_MODULE_11__.SideButton({
            command: command,
            commandRegistry: app.commands,
            labShell,
            caption: 'PyUnicore Tasks Stream',
            icon: unicoreIcon,
            area: 'right',
            shellOptions: { rank: 10 }
        });
        sideBtn.addToLabShell();
        restorer.restore(tracker, {
            command,
            name: () => 'pyunicore'
        });
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (plugin);
var Private;
(function (Private) {
    /**
     * Whether a kernel should be used. Only evaluates to true
     * if it is valid and in python.
     */
    async function shouldUseKernel(kernel) {
        if (!kernel) {
            return false;
        }
        const spec = await kernel.spec;
        return !!spec && spec.language.toLowerCase().indexOf('python') !== -1;
    }
    Private.shouldUseKernel = shouldUseKernel;
    /**
     * Get the currently focused kernel in the application,
     * checking both notebooks and consoles.
     */
    function getCurrentKernel(shell, notebookTracker, consoleTracker) {
        var _a, _b, _c, _d;
        // Get a handle on the most relevant kernel,
        // whether it is attached to a notebook or a console.
        let current = shell.currentWidget;
        let kernel;
        if (current && notebookTracker.has(current)) {
            kernel = (_a = current.sessionContext.session) === null || _a === void 0 ? void 0 : _a.kernel;
        }
        else if (current && consoleTracker.has(current)) {
            kernel = (_b = current.sessionContext.session) === null || _b === void 0 ? void 0 : _b.kernel;
        }
        else if (notebookTracker.currentWidget) {
            current = notebookTracker.currentWidget;
            kernel = (_c = current.sessionContext.session) === null || _c === void 0 ? void 0 : _c.kernel;
        }
        else if (consoleTracker.currentWidget) {
            current = consoleTracker.currentWidget;
            kernel = (_d = current.sessionContext.session) === null || _d === void 0 ? void 0 : _d.kernel;
        }
        return kernel;
    }
    Private.getCurrentKernel = getCurrentKernel;
    function getFileBrowser(factory) {
        return factory.createFileBrowser('default');
    }
    Private.getFileBrowser = getFileBrowser;
})(Private || (Private = {}));


/***/ }),

/***/ "./lib/pyunicoreWidget.js":
/*!********************************!*\
  !*** ./lib/pyunicoreWidget.js ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PyunicoreComponent: () => (/* binding */ PyunicoreComponent),
/* harmony export */   PyunicoreWidget: () => (/* binding */ PyunicoreWidget)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_UnicoreJobsTable__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./components/UnicoreJobsTable */ "./lib/components/UnicoreJobsTable.js");
/* harmony import */ var _components_PaginationComponent__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./components/PaginationComponent */ "./lib/components/PaginationComponent.js");
/* harmony import */ var _components_UnicoreSites__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./components/UnicoreSites */ "./lib/components/UnicoreSites.js");
/* harmony import */ var _components_ModalComponent__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./components/ModalComponent */ "./lib/components/ModalComponent.js");
/* harmony import */ var _handler__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./handler */ "./lib/handler.js");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./constants */ "./lib/constants.js");








/**
 * React Widget wrapper over the React component to add the @lumino widget functionality
 */
class PyunicoreWidget extends _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__.ReactWidget {
    constructor(props) {
        super();
        this.addClass('tvb-pyunicoreWidget');
        this.props = props;
    }
    render() {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement(PyunicoreComponent, { tableFormat: this.props.tableFormat, data: this.props.data, buttonSettings: this.props.buttonSettings, sites: this.props.sites, defaultSite: this.props.defaultSite, reloadRate: _constants__WEBPACK_IMPORTED_MODULE_2__.RELOAD_RATE_MS, getKernel: this.props.getKernel, getJobCode: this.props.getJobCode, getFileBrowser: this.props.getFileBrowser }) // see how we can wrap this to use signal
        );
    }
}
/**
 * main React class component for the PyUnicore integration, extends React.Component to render
 * a table and other custom behaviour
 */
class PyunicoreComponent extends (react__WEBPACK_IMPORTED_MODULE_0___default().Component) {
    constructor(props) {
        super(props);
        /**
         * Main function that triggers an update of the jobs from current site
         * @param ignoreRefreshRate - if true will ignore how much time has passed since last update
         */
        this._triggerUpdate = (ignoreRefreshRate = false) => {
            if (this.state.site === _constants__WEBPACK_IMPORTED_MODULE_2__.NO_SITE) {
                return;
            }
            if (ignoreRefreshRate) {
                this.setState(prevState => ({ ...prevState, isRefresh: true }));
                return;
            }
            else if (!this.state.autoReload) {
                return;
            }
            const now = new Date().valueOf();
            const previous = this.state.lastUpdate.valueOf();
            const diff = now - previous;
            if (diff >= this.state.reloadRate && !this.state.loading) {
                this.setState(prevState => ({ ...prevState, isRefresh: true }));
            }
        };
        // bind helper methods to pass them as props to children
        this.setPageState = this.setPageState.bind(this);
        this.setSiteState = this.setSiteState.bind(this);
        this.setModalSateVisible = this.setModalSateVisible.bind(this);
        this.getData = this.getData.bind(this);
        this.catchError = this.catchError.bind(this);
        this.setAutoReload = this.setAutoReload.bind(this);
        const lastUpdate = new Date();
        this.state = {
            jobs: [],
            message: props.data.message,
            site: props.defaultSite,
            buttonSettings: props.buttonSettings,
            tableFormat: props.tableFormat,
            reloadRate: _constants__WEBPACK_IMPORTED_MODULE_2__.RELOAD_RATE_MS,
            loading: props.sites.length > 0,
            sites: props.sites,
            page: 1,
            itemsPerPage: 10,
            lastUpdate: lastUpdate,
            renderLeftArrow: false,
            renderRightArrow: false,
            disableSitesSelection: true,
            modalState: {
                modalType: _components_ModalComponent__WEBPACK_IMPORTED_MODULE_3__.ModalType.Error,
                message: '',
                visible: false,
                setVisible: this.setModalSateVisible
            },
            autoReload: true,
            isRefresh: false,
            updateIntervalId: 0 // set when component mounts
        };
    }
    /**
     * method to get the api endpoint from current state
     * @private
     */
    _getEndpoint() {
        return `jobs?site=${this.state.site}&page=${this.state.page}`;
    }
    /**
     * method to fetch data from api and toggle pagination buttons, sites, loading wheel,
     * before and after data loads
     * @protected
     */
    async getData() {
        this.setState(prevState => ({
            ...prevState,
            loading: true,
            renderLeftArrow: false,
            renderRightArrow: false,
            disableSitesSelection: true
        }));
        const data = await (0,_handler__WEBPACK_IMPORTED_MODULE_4__.requestAPI)(this._getEndpoint());
        this.setState(prevState => ({
            ...prevState,
            jobs: data.jobs,
            message: data.message,
            loading: false,
            lastUpdate: new Date(),
            renderLeftArrow: prevState.page > 1,
            renderRightArrow: data.jobs.length >= prevState.itemsPerPage,
            disableSitesSelection: false,
            isRefresh: false
        }));
        return data;
    }
    /**
     * helper method to set page state from a child component
     * @param page
     * @protected
     */
    setPageState(page) {
        this.setState(prevState => ({ ...prevState, page: page }));
    }
    /**
     * helper method to set modal visibility from modal component
     * @param visible
     * @protected
     */
    setModalSateVisible(visible) {
        this.setState(prevState => ({
            ...prevState,
            loading: false,
            renderLeftArrow: true,
            renderRightArrow: true,
            disableSitesSelection: false,
            modalState: { ...prevState.modalState, visible: visible }
        }));
    }
    /**
     * helper method to set site state from a child component
     * @param site
     * @protected
     */
    setSiteState(site) {
        // reset the page to 1 when changing site
        this.setState(prevState => ({
            ...prevState,
            page: 1,
            site: site,
            jobs: site === _constants__WEBPACK_IMPORTED_MODULE_2__.NO_SITE ? [] : prevState.jobs
        }));
    }
    /**
     * Method to set state of auto update functionality
     * @param active - active state of the reload functionality
     * @protected
     */
    setAutoReload(active) {
        this.setState(prevState => ({ ...prevState, autoReload: active }));
    }
    /**
     * if page or site changed reload data
     * @param _prevProps
     * @param prevState
     */
    componentDidUpdate(_prevProps, prevState) {
        if (((this.state.isRefresh && !prevState.isRefresh) ||
            prevState.page !== this.state.page ||
            prevState.site !== this.state.site) &&
            this.state.sites.length > 0) {
            if (this.state.site === _constants__WEBPACK_IMPORTED_MODULE_2__.NO_SITE) {
                this.setState(prevState => ({
                    ...prevState,
                    loading: false,
                    disableSitesSelection: false,
                    jobs: [],
                    renderLeftArrow: false,
                    renderRightArrow: false,
                    isRefresh: false
                }));
                return;
            }
            this.getData().catch(this.catchError);
        }
    }
    /**
     * helper function to catch an error and update the state to show modal with error
     * @param reason
     * @private
     */
    catchError(reason) {
        this.setState(prevState => ({
            ...prevState,
            modalState: {
                ...prevState.modalState,
                visible: true,
                message: reason
            }
        }));
    }
    /**
     * clear interval to avoid unnecessary reloads
     */
    componentWillUnmount() {
        const { updateIntervalId } = this.state;
        if (typeof updateIntervalId === 'number' ||
            (typeof updateIntervalId === 'object' && updateIntervalId !== null)) {
            clearInterval(updateIntervalId);
        }
    }
    /**
     * lifecycle method, override to load data from api when component is mounted
     */
    componentDidMount() {
        // TODO: Try to replace with setTimeout
        const updateIntervalId = setInterval(this._triggerUpdate, _constants__WEBPACK_IMPORTED_MODULE_2__.RELOAD_CHECK_RATE_MS);
        this.setState({ ...this.state, updateIntervalId: updateIntervalId });
        if (this.state.site === _constants__WEBPACK_IMPORTED_MODULE_2__.NO_SITE) {
            this.setState(prevState => ({
                ...prevState,
                loading: false,
                disableSitesSelection: false
            }));
            return;
        }
        if (this.state.sites.length <= 0) {
            return;
        }
        this.getData().catch(this.catchError);
    }
    /**
     * combine the React components together
     */
    render() {
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null,
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_components_ModalComponent__WEBPACK_IMPORTED_MODULE_3__.ModalWidget, { modalType: this.state.modalState.modalType, message: this.state.modalState.message, visible: this.state.modalState.visible, setVisible: this.state.modalState.setVisible }),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'unicoreTopBar' },
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_components_PaginationComponent__WEBPACK_IMPORTED_MODULE_5__.PaginationComponent, { setPageState: this.setPageState, showNextButton: this.state.renderRightArrow, showPrevButton: this.state.renderLeftArrow, currentPage: this.state.page }),
                react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_components_UnicoreSites__WEBPACK_IMPORTED_MODULE_6__.UnicoreSites, { sites: this.state.sites, onChangeSite: this.setSiteState, defaultSite: this.state.site, disableSelection: this.state.disableSitesSelection, refreshSite: () => this._triggerUpdate(true), loading: this.state.loading, setAutoReload: this.setAutoReload }),
                this.state.loading ? (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", { className: 'loadingRoot' },
                        react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: 'unicoreLoading' })))) : (react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", null,
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: 'unicoreMessage' }, this.state.message),
                    react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", { className: 'lastUpdate' },
                        "Last update: ",
                        this.state.lastUpdate.toLocaleTimeString())))),
            react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_components_UnicoreJobsTable__WEBPACK_IMPORTED_MODULE_7__.UnicoreJobsTable, { buttonSettings: this.state.buttonSettings, afterButtonSettingClick: this.getData, columns: this.state.tableFormat.cols, data: this.state.jobs, setMessageState: (message) => {
                    this.setState(prevState => ({ ...prevState, message: message }));
                }, getKernel: this.props.getKernel, getJob: this.props.getJobCode, handleError: this.catchError, getFileBrowser: this.props.getFileBrowser })));
    }
}


/***/ }),

/***/ "./lib/utils.js":
/*!**********************!*\
  !*** ./lib/utils.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   validateDefaultSite: () => (/* binding */ validateDefaultSite)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./constants */ "./lib/constants.js");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__);


/**
 * Checks if a site name is among the available sites. If site is not available 'NONE' is returned
 * @param site
 * @param availableSites
 */
function validateDefaultSite(site, availableSites) {
    if (site !== _constants__WEBPACK_IMPORTED_MODULE_1__.NO_SITE && site !== undefined && site !== null) {
        if (!availableSites.includes(site)) {
            (0,_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.showErrorMessage)('SITE ERROR', `Site ${site} is not available at this time! Available sites: ${availableSites}`);
            return _constants__WEBPACK_IMPORTED_MODULE_1__.NO_SITE;
        }
        return site;
    }
    return _constants__WEBPACK_IMPORTED_MODULE_1__.NO_SITE;
}


/***/ }),

/***/ "./style/icons/logo-unicore.svg":
/*!**************************************!*\
  !*** ./style/icons/logo-unicore.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<?xml version=\"1.0\" standalone=\"no\"?>\n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20010904//EN\"\n \"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\n<svg version=\"1.0\" xmlns=\"http://www.w3.org/2000/svg\"\n width=\"37.000000pt\" height=\"45.000000pt\" viewBox=\"0 0 37.000000 45.000000\"\n preserveAspectRatio=\"xMidYMid meet\">\n\n<g transform=\"translate(7.000000,35.000000) scale(0.0700000,-0.0700000)\"\nfill=\"#616161\" stroke=\"none\">\n<path d=\"M2 373 c3 -144 6 -173 22 -200 28 -46 83 -73 148 -73 72 0 117 25\n145 80 21 40 23 58 23 202 l0 158 -40 0 -40 0 0 -160 c0 -157 -1 -161 -25\n-185 -17 -18 -35 -25 -62 -25 -80 1 -93 31 -93 219 l0 151 -41 0 -41 0 4 -167z\"/>\n<path d=\"M10 25 l0 -25 165 0 165 0 0 25 0 25 -165 0 -165 0 0 -25z\"/>\n</g>\n</svg>\n";

/***/ })

}]);
//# sourceMappingURL=lib_index_js.e80e181cb905e24b215b.js.map