"use strict";
(self["webpackChunktvb_ext_unicore"] = self["webpackChunktvb_ext_unicore"] || []).push([["style_index_js"],{

/***/ "./node_modules/css-loader/dist/runtime/api.js":
/*!*****************************************************!*\
  !*** ./node_modules/css-loader/dist/runtime/api.js ***!
  \*****************************************************/
/***/ ((module) => {



/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
module.exports = function (cssWithMappingToString) {
  var list = [];

  // return the list of modules as css string
  list.toString = function toString() {
    return this.map(function (item) {
      var content = "";
      var needLayer = typeof item[5] !== "undefined";
      if (item[4]) {
        content += "@supports (".concat(item[4], ") {");
      }
      if (item[2]) {
        content += "@media ".concat(item[2], " {");
      }
      if (needLayer) {
        content += "@layer".concat(item[5].length > 0 ? " ".concat(item[5]) : "", " {");
      }
      content += cssWithMappingToString(item);
      if (needLayer) {
        content += "}";
      }
      if (item[2]) {
        content += "}";
      }
      if (item[4]) {
        content += "}";
      }
      return content;
    }).join("");
  };

  // import a list of modules into the list
  list.i = function i(modules, media, dedupe, supports, layer) {
    if (typeof modules === "string") {
      modules = [[null, modules, undefined]];
    }
    var alreadyImportedModules = {};
    if (dedupe) {
      for (var k = 0; k < this.length; k++) {
        var id = this[k][0];
        if (id != null) {
          alreadyImportedModules[id] = true;
        }
      }
    }
    for (var _k = 0; _k < modules.length; _k++) {
      var item = [].concat(modules[_k]);
      if (dedupe && alreadyImportedModules[item[0]]) {
        continue;
      }
      if (typeof layer !== "undefined") {
        if (typeof item[5] === "undefined") {
          item[5] = layer;
        } else {
          item[1] = "@layer".concat(item[5].length > 0 ? " ".concat(item[5]) : "", " {").concat(item[1], "}");
          item[5] = layer;
        }
      }
      if (media) {
        if (!item[2]) {
          item[2] = media;
        } else {
          item[1] = "@media ".concat(item[2], " {").concat(item[1], "}");
          item[2] = media;
        }
      }
      if (supports) {
        if (!item[4]) {
          item[4] = "".concat(supports);
        } else {
          item[1] = "@supports (".concat(item[4], ") {").concat(item[1], "}");
          item[4] = supports;
        }
      }
      list.push(item);
    }
  };
  return list;
};

/***/ }),

/***/ "./node_modules/css-loader/dist/runtime/sourceMaps.js":
/*!************************************************************!*\
  !*** ./node_modules/css-loader/dist/runtime/sourceMaps.js ***!
  \************************************************************/
/***/ ((module) => {



module.exports = function (item) {
  var content = item[1];
  var cssMapping = item[3];
  if (!cssMapping) {
    return content;
  }
  if (typeof btoa === "function") {
    var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(cssMapping))));
    var data = "sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(base64);
    var sourceMapping = "/*# ".concat(data, " */");
    return [content].concat([sourceMapping]).join("\n");
  }
  return [content].join("\n");
};

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js":
/*!****************************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js ***!
  \****************************************************************************/
/***/ ((module) => {



var stylesInDOM = [];
function getIndexByIdentifier(identifier) {
  var result = -1;
  for (var i = 0; i < stylesInDOM.length; i++) {
    if (stylesInDOM[i].identifier === identifier) {
      result = i;
      break;
    }
  }
  return result;
}
function modulesToDom(list, options) {
  var idCountMap = {};
  var identifiers = [];
  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var id = options.base ? item[0] + options.base : item[0];
    var count = idCountMap[id] || 0;
    var identifier = "".concat(id, " ").concat(count);
    idCountMap[id] = count + 1;
    var indexByIdentifier = getIndexByIdentifier(identifier);
    var obj = {
      css: item[1],
      media: item[2],
      sourceMap: item[3],
      supports: item[4],
      layer: item[5]
    };
    if (indexByIdentifier !== -1) {
      stylesInDOM[indexByIdentifier].references++;
      stylesInDOM[indexByIdentifier].updater(obj);
    } else {
      var updater = addElementStyle(obj, options);
      options.byIndex = i;
      stylesInDOM.splice(i, 0, {
        identifier: identifier,
        updater: updater,
        references: 1
      });
    }
    identifiers.push(identifier);
  }
  return identifiers;
}
function addElementStyle(obj, options) {
  var api = options.domAPI(options);
  api.update(obj);
  var updater = function updater(newObj) {
    if (newObj) {
      if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap && newObj.supports === obj.supports && newObj.layer === obj.layer) {
        return;
      }
      api.update(obj = newObj);
    } else {
      api.remove();
    }
  };
  return updater;
}
module.exports = function (list, options) {
  options = options || {};
  list = list || [];
  var lastIdentifiers = modulesToDom(list, options);
  return function update(newList) {
    newList = newList || [];
    for (var i = 0; i < lastIdentifiers.length; i++) {
      var identifier = lastIdentifiers[i];
      var index = getIndexByIdentifier(identifier);
      stylesInDOM[index].references--;
    }
    var newLastIdentifiers = modulesToDom(newList, options);
    for (var _i = 0; _i < lastIdentifiers.length; _i++) {
      var _identifier = lastIdentifiers[_i];
      var _index = getIndexByIdentifier(_identifier);
      if (stylesInDOM[_index].references === 0) {
        stylesInDOM[_index].updater();
        stylesInDOM.splice(_index, 1);
      }
    }
    lastIdentifiers = newLastIdentifiers;
  };
};

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/insertBySelector.js":
/*!********************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/insertBySelector.js ***!
  \********************************************************************/
/***/ ((module) => {



var memo = {};

/* istanbul ignore next  */
function getTarget(target) {
  if (typeof memo[target] === "undefined") {
    var styleTarget = document.querySelector(target);

    // Special case to return head of iframe instead of iframe itself
    if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
      try {
        // This will throw an exception if access to iframe is blocked
        // due to cross-origin restrictions
        styleTarget = styleTarget.contentDocument.head;
      } catch (e) {
        // istanbul ignore next
        styleTarget = null;
      }
    }
    memo[target] = styleTarget;
  }
  return memo[target];
}

/* istanbul ignore next  */
function insertBySelector(insert, style) {
  var target = getTarget(insert);
  if (!target) {
    throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
  }
  target.appendChild(style);
}
module.exports = insertBySelector;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/insertStyleElement.js":
/*!**********************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/insertStyleElement.js ***!
  \**********************************************************************/
/***/ ((module) => {



/* istanbul ignore next  */
function insertStyleElement(options) {
  var element = document.createElement("style");
  options.setAttributes(element, options.attributes);
  options.insert(element, options.options);
  return element;
}
module.exports = insertStyleElement;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js":
/*!**********************************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js ***!
  \**********************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



/* istanbul ignore next  */
function setAttributesWithoutAttributes(styleElement) {
  var nonce =  true ? __webpack_require__.nc : 0;
  if (nonce) {
    styleElement.setAttribute("nonce", nonce);
  }
}
module.exports = setAttributesWithoutAttributes;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/styleDomAPI.js":
/*!***************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/styleDomAPI.js ***!
  \***************************************************************/
/***/ ((module) => {



/* istanbul ignore next  */
function apply(styleElement, options, obj) {
  var css = "";
  if (obj.supports) {
    css += "@supports (".concat(obj.supports, ") {");
  }
  if (obj.media) {
    css += "@media ".concat(obj.media, " {");
  }
  var needLayer = typeof obj.layer !== "undefined";
  if (needLayer) {
    css += "@layer".concat(obj.layer.length > 0 ? " ".concat(obj.layer) : "", " {");
  }
  css += obj.css;
  if (needLayer) {
    css += "}";
  }
  if (obj.media) {
    css += "}";
  }
  if (obj.supports) {
    css += "}";
  }
  var sourceMap = obj.sourceMap;
  if (sourceMap && typeof btoa !== "undefined") {
    css += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))), " */");
  }

  // For old IE
  /* istanbul ignore if  */
  options.styleTagTransform(css, styleElement, options.options);
}
function removeStyleElement(styleElement) {
  // istanbul ignore if
  if (styleElement.parentNode === null) {
    return false;
  }
  styleElement.parentNode.removeChild(styleElement);
}

/* istanbul ignore next  */
function domAPI(options) {
  if (typeof document === "undefined") {
    return {
      update: function update() {},
      remove: function remove() {}
    };
  }
  var styleElement = options.insertStyleElement(options);
  return {
    update: function update(obj) {
      apply(styleElement, options, obj);
    },
    remove: function remove() {
      removeStyleElement(styleElement);
    }
  };
}
module.exports = domAPI;

/***/ }),

/***/ "./node_modules/style-loader/dist/runtime/styleTagTransform.js":
/*!*********************************************************************!*\
  !*** ./node_modules/style-loader/dist/runtime/styleTagTransform.js ***!
  \*********************************************************************/
/***/ ((module) => {



/* istanbul ignore next  */
function styleTagTransform(css, styleElement) {
  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = css;
  } else {
    while (styleElement.firstChild) {
      styleElement.removeChild(styleElement.firstChild);
    }
    styleElement.appendChild(document.createTextNode(css));
  }
}
module.exports = styleTagTransform;

/***/ }),

/***/ "./style/index.js":
/*!************************!*\
  !*** ./style/index.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _base_css__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base.css */ "./style/base.css");



/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js!./style/base.css":
/*!**************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js!./style/base.css ***!
  \**************************************************************/
/***/ ((module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/css-loader/dist/runtime/sourceMaps.js */ "./node_modules/css-loader/dist/runtime/sourceMaps.js");
/* harmony import */ var _node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/css-loader/dist/runtime/api.js */ "./node_modules/css-loader/dist/runtime/api.js");
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1__);
// Imports


var ___CSS_LOADER_EXPORT___ = _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_1___default()((_node_modules_css_loader_dist_runtime_sourceMaps_js__WEBPACK_IMPORTED_MODULE_0___default()));
// Module
___CSS_LOADER_EXPORT___.push([module.id, `.tvb-pyunicoreWidget {
    background-color: whitesmoke;
    font-family: var(--jp-ui-font-family);
    max-height: 100vh;
    overflow-y: auto;
    overflow-x: hidden;
}

.tvb-pyunicoreWidget > div {
    margin-top: 0.2rem;
}

.tvb-pyunicoreWidget table {
    width: 100%;
    border: var(--jp-border-width) solid black;
    border-collapse: collapse;
    background-color: white;
    color: black;
    text-align: center;
    vertical-align: middle;
    overflow: hidden;
}

.tvb-pyunicoreWidget tr {
    border-bottom: 1px solid black;
}

/* hint that table rows that aren't with details are clickable */
.tvb-pyunicoreWidget tbody tr:not(.detailsRow) {
    cursor: pointer;
}
.tvb-pyunicoreWidget tbody tr:not(.detailsRow):hover {
    box-shadow: 0 0 7px 0 rgba(0, 0, 0, 0.2);
}

.tvb-pyunicoreWidget tbody tr:nth-child(even) {
    background-color: whitesmoke;
}

.tvb-pyunicoreWidget td, th {
    padding: 8px;
}

.tvb-pyunicoreWidget table, body {
    font-family: var(--jp-ui-font-family);
}

.tvb-pyunicoreWidget thead {
    background-color: lightgray;
    text-transform: uppercase;
}

.tvb-pyunicoreWidget button {
    padding: 8px 16px;
    border: 1px solid black;
    border-radius: 7px;
    background-color: white;
    color: black;
}

.tvb-pyunicoreWidget button:hover {
    box-shadow: 0 12px 16px 0 rgba(0,0,0,0.24), 0 17px 50px 0 rgba(0,0,0,0.19);
    cursor: pointer;
}
/**
top bar style
 */
.unicoreTopBar {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: flex-start;
    padding-bottom: 0.2rem;
}
/* end top bar */
.lastUpdate {
    margin-left: 1rem;
}
/**
details section style
 */
.tvb-pyunicoreWidget .detailsRow td {
    column-span: all;
    padding-top: 0;
    padding-bottom: 0;
    padding-right: 0;
    width: 100%;
}
.tvb-pyunicoreWidget .detailsRow textarea {
    width: 100%;
    height: 10rem;
    border: none;
}
/* end details section style */

/**
selection component (pyunicore sites)
 */
.pyunicoreSites {
    display: flex;
    flex-direction: row;
    margin: 0 1rem 0 0 ;
}

@-moz-keyframes spin {
    from { -moz-transform: rotate(0deg); }
    to { -moz-transform: rotate(360deg); }
}
@-webkit-keyframes spin {
    from { -webkit-transform: rotate(0deg); }
    to { -webkit-transform: rotate(360deg); }
}
@keyframes spin {
    from {transform:rotate(0deg);}
    to {transform:rotate(360deg);}
}

.spin {
    -webkit-animation: spin 1s infinite linear;
    animation: spin 0.5s infinite linear;
}

.pyunicoreSites .refreshBtn {
    border: none;
    padding: 5px;
    background: none;
}
.pyunicoreSites div{
    border: var(--jp-border-width) solid var(--jp-border-color1);
    border-radius: 7px;
    padding: 0.2rem;
    display: flex;
    align-items: center;
    justify-content: center;
}
.pyunicoreSites select {
    background-color: whitesmoke;
    border: none;
}
.pyunicoreSites span {
    text-transform: uppercase;
    font-weight: bold;
    margin-left: 1rem;
}
/* end selection style */

/* modal styling */
.unicoreModal {
    position: absolute;
    background-color: rgba(0,0,0,0.2);
    width: 100%;
    height: 100%;
    z-index: 5;
    top: 0;
    left: 0;
    display: flex;
    align-items: center;
    justify-content: center;
}

.unicoreModal > div {
    width: 40%;
    min-height: 5rem;
    background-color: whitesmoke;
    border-radius: 7px;
    /*padding: 1rem;*/
    box-shadow: 0 0 10px 0 rgba(185,185,185, .4);
}
.unicoreModal > div h3 {
    padding: 0;
    margin: 0;
}

.unicoreModal > div > div:first-child {
    background-color: var(--jp-error-color1);
    border-radius: 7px 7px 0 0;
    color: whitesmoke;
}
.unicoreModal > div > div {
    padding: 1rem;
    margin: 0;
}

.unicoreModal button {
    background-color: var(--jp-error-color1);
    color: whitesmoke;
    padding: 0.5rem 1rem;
    border-radius: 7px;
    border: none;
    box-shadow: 0 0 7px 0 rgba(185,185,185, .4);
    cursor: pointer;
}

.unicoreModal button:hover {
    box-shadow: 0 0 14px 0 rgba(0,0,0, .4);
}
/* end modal style */

/* loading animation */
@keyframes circle{
  0%{
    transform:rotate(0deg);
  }
  100%{
    transform:rotate(360deg);
  }
}
.loadingRoot {
    display: flex;
    align-items: center;
    justify-content: center;
}


.unicoreLoading {
    width: 0.9rem;
    height: 0.9rem;
    display: inline-block;
    border-radius: 50%;
    border: 3px solid var(--jp-border-color1);
    border-top: 3px solid var(--jp-cell-editor-active-border-color);
    animation: circle 0.5s linear infinite;
}

.unicoreMessage {
    color: var(--jp-error-color1);
}

.unicoreMessage-success {
    color: var(--jp-success-color1);
}

.unicoreMessage-warning {
    color: var(--jp-warn-color1);
}

/**
pagination style
 */
.unicorePagination {
    display: inline-block;
    border: var(--jp-border-width) solid var(--jp-border-color1);
    border-radius: 7px;
    margin-right: 1rem;
    /*margin-left: 0.5rem;*/
}
.unicorePagination div{
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
}
.unicorePagination > div div {
    min-width: 1rem;
    padding: 0.2rem;
    height: 100%;
}
.unicorePagination button {
    padding: 0;
    border: none;
    margin: 0;
    display: flex;
    align-items: center;
    justify-content: center;
    background-color: whitesmoke;
    color: var(--jp-border-color1);
}

button:disabled,
button[disabled]{
    color: #ababab;
    box-shadow: none;
}

button:disabled:hover,
button[disabled]:hover {
    box-shadow: none;
    cursor: initial;
}

.currentPageContainer {
    border-left: var(--jp-border-width) solid var(--jp-border-color1);
    border-right: var(--jp-border-width) solid var(--jp-border-color1);
    padding: 0 0.2rem;
}


/*----- output files -----*/
.unicore-jobOutput {
    display: flex;
    flex-direction: row;
    height: 1.3rem;
    align-items: center;
    margin: 0.1rem 0;
}

.outputFiles {
    text-align: left;
}

.outputFileName {
    margin: 0 0.5rem 0 0.2rem;
    display: inline-block;
}

.clickableIcon {
    cursor: pointer;
}

.clickableIcon:focus {
    outline: #2b2b2c solid 2px;
    outline-offset: 2px;
}

i {
    color: var(--jp-content-font-color2);
}`, "",{"version":3,"sources":["webpack://./style/base.css"],"names":[],"mappings":"AAAA;IACI,4BAA4B;IAC5B,qCAAqC;IACrC,iBAAiB;IACjB,gBAAgB;IAChB,kBAAkB;AACtB;;AAEA;IACI,kBAAkB;AACtB;;AAEA;IACI,WAAW;IACX,0CAA0C;IAC1C,yBAAyB;IACzB,uBAAuB;IACvB,YAAY;IACZ,kBAAkB;IAClB,sBAAsB;IACtB,gBAAgB;AACpB;;AAEA;IACI,8BAA8B;AAClC;;AAEA,gEAAgE;AAChE;IACI,eAAe;AACnB;AACA;IACI,wCAAwC;AAC5C;;AAEA;IACI,4BAA4B;AAChC;;AAEA;IACI,YAAY;AAChB;;AAEA;IACI,qCAAqC;AACzC;;AAEA;IACI,2BAA2B;IAC3B,yBAAyB;AAC7B;;AAEA;IACI,iBAAiB;IACjB,uBAAuB;IACvB,kBAAkB;IAClB,uBAAuB;IACvB,YAAY;AAChB;;AAEA;IACI,0EAA0E;IAC1E,eAAe;AACnB;AACA;;EAEE;AACF;IACI,aAAa;IACb,mBAAmB;IACnB,mBAAmB;IACnB,2BAA2B;IAC3B,sBAAsB;AAC1B;AACA,gBAAgB;AAChB;IACI,iBAAiB;AACrB;AACA;;EAEE;AACF;IACI,gBAAgB;IAChB,cAAc;IACd,iBAAiB;IACjB,gBAAgB;IAChB,WAAW;AACf;AACA;IACI,WAAW;IACX,aAAa;IACb,YAAY;AAChB;AACA,8BAA8B;;AAE9B;;EAEE;AACF;IACI,aAAa;IACb,mBAAmB;IACnB,mBAAmB;AACvB;;AAEA;IACI,OAAO,4BAA4B,EAAE;IACrC,KAAK,8BAA8B,EAAE;AACzC;AACA;IACI,OAAO,+BAA+B,EAAE;IACxC,KAAK,iCAAiC,EAAE;AAC5C;AACA;IACI,MAAM,sBAAsB,CAAC;IAC7B,IAAI,wBAAwB,CAAC;AACjC;;AAEA;IACI,0CAA0C;IAC1C,oCAAoC;AACxC;;AAEA;IACI,YAAY;IACZ,YAAY;IACZ,gBAAgB;AACpB;AACA;IACI,4DAA4D;IAC5D,kBAAkB;IAClB,eAAe;IACf,aAAa;IACb,mBAAmB;IACnB,uBAAuB;AAC3B;AACA;IACI,4BAA4B;IAC5B,YAAY;AAChB;AACA;IACI,yBAAyB;IACzB,iBAAiB;IACjB,iBAAiB;AACrB;AACA,wBAAwB;;AAExB,kBAAkB;AAClB;IACI,kBAAkB;IAClB,iCAAiC;IACjC,WAAW;IACX,YAAY;IACZ,UAAU;IACV,MAAM;IACN,OAAO;IACP,aAAa;IACb,mBAAmB;IACnB,uBAAuB;AAC3B;;AAEA;IACI,UAAU;IACV,gBAAgB;IAChB,4BAA4B;IAC5B,kBAAkB;IAClB,iBAAiB;IACjB,4CAA4C;AAChD;AACA;IACI,UAAU;IACV,SAAS;AACb;;AAEA;IACI,wCAAwC;IACxC,0BAA0B;IAC1B,iBAAiB;AACrB;AACA;IACI,aAAa;IACb,SAAS;AACb;;AAEA;IACI,wCAAwC;IACxC,iBAAiB;IACjB,oBAAoB;IACpB,kBAAkB;IAClB,YAAY;IACZ,2CAA2C;IAC3C,eAAe;AACnB;;AAEA;IACI,sCAAsC;AAC1C;AACA,oBAAoB;;AAEpB,sBAAsB;AACtB;EACE;IACE,sBAAsB;EACxB;EACA;IACE,wBAAwB;EAC1B;AACF;AACA;IACI,aAAa;IACb,mBAAmB;IACnB,uBAAuB;AAC3B;;;AAGA;IACI,aAAa;IACb,cAAc;IACd,qBAAqB;IACrB,kBAAkB;IAClB,yCAAyC;IACzC,+DAA+D;IAC/D,sCAAsC;AAC1C;;AAEA;IACI,6BAA6B;AACjC;;AAEA;IACI,+BAA+B;AACnC;;AAEA;IACI,4BAA4B;AAChC;;AAEA;;EAEE;AACF;IACI,qBAAqB;IACrB,4DAA4D;IAC5D,kBAAkB;IAClB,kBAAkB;IAClB,uBAAuB;AAC3B;AACA;IACI,aAAa;IACb,mBAAmB;IACnB,mBAAmB;IACnB,uBAAuB;AAC3B;AACA;IACI,eAAe;IACf,eAAe;IACf,YAAY;AAChB;AACA;IACI,UAAU;IACV,YAAY;IACZ,SAAS;IACT,aAAa;IACb,mBAAmB;IACnB,uBAAuB;IACvB,4BAA4B;IAC5B,8BAA8B;AAClC;;AAEA;;IAEI,cAAc;IACd,gBAAgB;AACpB;;AAEA;;IAEI,gBAAgB;IAChB,eAAe;AACnB;;AAEA;IACI,iEAAiE;IACjE,kEAAkE;IAClE,iBAAiB;AACrB;;;AAGA,2BAA2B;AAC3B;IACI,aAAa;IACb,mBAAmB;IACnB,cAAc;IACd,mBAAmB;IACnB,gBAAgB;AACpB;;AAEA;IACI,gBAAgB;AACpB;;AAEA;IACI,yBAAyB;IACzB,qBAAqB;AACzB;;AAEA;IACI,eAAe;AACnB;;AAEA;IACI,0BAA0B;IAC1B,mBAAmB;AACvB;;AAEA;IACI,oCAAoC;AACxC","sourcesContent":[".tvb-pyunicoreWidget {\n    background-color: whitesmoke;\n    font-family: var(--jp-ui-font-family);\n    max-height: 100vh;\n    overflow-y: auto;\n    overflow-x: hidden;\n}\n\n.tvb-pyunicoreWidget > div {\n    margin-top: 0.2rem;\n}\n\n.tvb-pyunicoreWidget table {\n    width: 100%;\n    border: var(--jp-border-width) solid black;\n    border-collapse: collapse;\n    background-color: white;\n    color: black;\n    text-align: center;\n    vertical-align: middle;\n    overflow: hidden;\n}\n\n.tvb-pyunicoreWidget tr {\n    border-bottom: 1px solid black;\n}\n\n/* hint that table rows that aren't with details are clickable */\n.tvb-pyunicoreWidget tbody tr:not(.detailsRow) {\n    cursor: pointer;\n}\n.tvb-pyunicoreWidget tbody tr:not(.detailsRow):hover {\n    box-shadow: 0 0 7px 0 rgba(0, 0, 0, 0.2);\n}\n\n.tvb-pyunicoreWidget tbody tr:nth-child(even) {\n    background-color: whitesmoke;\n}\n\n.tvb-pyunicoreWidget td, th {\n    padding: 8px;\n}\n\n.tvb-pyunicoreWidget table, body {\n    font-family: var(--jp-ui-font-family);\n}\n\n.tvb-pyunicoreWidget thead {\n    background-color: lightgray;\n    text-transform: uppercase;\n}\n\n.tvb-pyunicoreWidget button {\n    padding: 8px 16px;\n    border: 1px solid black;\n    border-radius: 7px;\n    background-color: white;\n    color: black;\n}\n\n.tvb-pyunicoreWidget button:hover {\n    box-shadow: 0 12px 16px 0 rgba(0,0,0,0.24), 0 17px 50px 0 rgba(0,0,0,0.19);\n    cursor: pointer;\n}\n/**\ntop bar style\n */\n.unicoreTopBar {\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n    justify-content: flex-start;\n    padding-bottom: 0.2rem;\n}\n/* end top bar */\n.lastUpdate {\n    margin-left: 1rem;\n}\n/**\ndetails section style\n */\n.tvb-pyunicoreWidget .detailsRow td {\n    column-span: all;\n    padding-top: 0;\n    padding-bottom: 0;\n    padding-right: 0;\n    width: 100%;\n}\n.tvb-pyunicoreWidget .detailsRow textarea {\n    width: 100%;\n    height: 10rem;\n    border: none;\n}\n/* end details section style */\n\n/**\nselection component (pyunicore sites)\n */\n.pyunicoreSites {\n    display: flex;\n    flex-direction: row;\n    margin: 0 1rem 0 0 ;\n}\n\n@-moz-keyframes spin {\n    from { -moz-transform: rotate(0deg); }\n    to { -moz-transform: rotate(360deg); }\n}\n@-webkit-keyframes spin {\n    from { -webkit-transform: rotate(0deg); }\n    to { -webkit-transform: rotate(360deg); }\n}\n@keyframes spin {\n    from {transform:rotate(0deg);}\n    to {transform:rotate(360deg);}\n}\n\n.spin {\n    -webkit-animation: spin 1s infinite linear;\n    animation: spin 0.5s infinite linear;\n}\n\n.pyunicoreSites .refreshBtn {\n    border: none;\n    padding: 5px;\n    background: none;\n}\n.pyunicoreSites div{\n    border: var(--jp-border-width) solid var(--jp-border-color1);\n    border-radius: 7px;\n    padding: 0.2rem;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n.pyunicoreSites select {\n    background-color: whitesmoke;\n    border: none;\n}\n.pyunicoreSites span {\n    text-transform: uppercase;\n    font-weight: bold;\n    margin-left: 1rem;\n}\n/* end selection style */\n\n/* modal styling */\n.unicoreModal {\n    position: absolute;\n    background-color: rgba(0,0,0,0.2);\n    width: 100%;\n    height: 100%;\n    z-index: 5;\n    top: 0;\n    left: 0;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.unicoreModal > div {\n    width: 40%;\n    min-height: 5rem;\n    background-color: whitesmoke;\n    border-radius: 7px;\n    /*padding: 1rem;*/\n    box-shadow: 0 0 10px 0 rgba(185,185,185, .4);\n}\n.unicoreModal > div h3 {\n    padding: 0;\n    margin: 0;\n}\n\n.unicoreModal > div > div:first-child {\n    background-color: var(--jp-error-color1);\n    border-radius: 7px 7px 0 0;\n    color: whitesmoke;\n}\n.unicoreModal > div > div {\n    padding: 1rem;\n    margin: 0;\n}\n\n.unicoreModal button {\n    background-color: var(--jp-error-color1);\n    color: whitesmoke;\n    padding: 0.5rem 1rem;\n    border-radius: 7px;\n    border: none;\n    box-shadow: 0 0 7px 0 rgba(185,185,185, .4);\n    cursor: pointer;\n}\n\n.unicoreModal button:hover {\n    box-shadow: 0 0 14px 0 rgba(0,0,0, .4);\n}\n/* end modal style */\n\n/* loading animation */\n@keyframes circle{\n  0%{\n    transform:rotate(0deg);\n  }\n  100%{\n    transform:rotate(360deg);\n  }\n}\n.loadingRoot {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n\n.unicoreLoading {\n    width: 0.9rem;\n    height: 0.9rem;\n    display: inline-block;\n    border-radius: 50%;\n    border: 3px solid var(--jp-border-color1);\n    border-top: 3px solid var(--jp-cell-editor-active-border-color);\n    animation: circle 0.5s linear infinite;\n}\n\n.unicoreMessage {\n    color: var(--jp-error-color1);\n}\n\n.unicoreMessage-success {\n    color: var(--jp-success-color1);\n}\n\n.unicoreMessage-warning {\n    color: var(--jp-warn-color1);\n}\n\n/**\npagination style\n */\n.unicorePagination {\n    display: inline-block;\n    border: var(--jp-border-width) solid var(--jp-border-color1);\n    border-radius: 7px;\n    margin-right: 1rem;\n    /*margin-left: 0.5rem;*/\n}\n.unicorePagination div{\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n    justify-content: center;\n}\n.unicorePagination > div div {\n    min-width: 1rem;\n    padding: 0.2rem;\n    height: 100%;\n}\n.unicorePagination button {\n    padding: 0;\n    border: none;\n    margin: 0;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    background-color: whitesmoke;\n    color: var(--jp-border-color1);\n}\n\nbutton:disabled,\nbutton[disabled]{\n    color: #ababab;\n    box-shadow: none;\n}\n\nbutton:disabled:hover,\nbutton[disabled]:hover {\n    box-shadow: none;\n    cursor: initial;\n}\n\n.currentPageContainer {\n    border-left: var(--jp-border-width) solid var(--jp-border-color1);\n    border-right: var(--jp-border-width) solid var(--jp-border-color1);\n    padding: 0 0.2rem;\n}\n\n\n/*----- output files -----*/\n.unicore-jobOutput {\n    display: flex;\n    flex-direction: row;\n    height: 1.3rem;\n    align-items: center;\n    margin: 0.1rem 0;\n}\n\n.outputFiles {\n    text-align: left;\n}\n\n.outputFileName {\n    margin: 0 0.5rem 0 0.2rem;\n    display: inline-block;\n}\n\n.clickableIcon {\n    cursor: pointer;\n}\n\n.clickableIcon:focus {\n    outline: #2b2b2c solid 2px;\n    outline-offset: 2px;\n}\n\ni {\n    color: var(--jp-content-font-color2);\n}"],"sourceRoot":""}]);
// Exports
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (___CSS_LOADER_EXPORT___);


/***/ }),

/***/ "./style/base.css":
/*!************************!*\
  !*** ./style/base.css ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/styleDomAPI.js */ "./node_modules/style-loader/dist/runtime/styleDomAPI.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/insertBySelector.js */ "./node_modules/style-loader/dist/runtime/insertBySelector.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js */ "./node_modules/style-loader/dist/runtime/setAttributesWithoutAttributes.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/insertStyleElement.js */ "./node_modules/style-loader/dist/runtime/insertStyleElement.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! !../node_modules/style-loader/dist/runtime/styleTagTransform.js */ "./node_modules/style-loader/dist/runtime/styleTagTransform.js");
/* harmony import */ var _node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! !!../node_modules/css-loader/dist/cjs.js!./base.css */ "./node_modules/css-loader/dist/cjs.js!./style/base.css");

      
      
      
      
      
      
      
      
      

var options = {};

options.styleTagTransform = (_node_modules_style_loader_dist_runtime_styleTagTransform_js__WEBPACK_IMPORTED_MODULE_5___default());
options.setAttributes = (_node_modules_style_loader_dist_runtime_setAttributesWithoutAttributes_js__WEBPACK_IMPORTED_MODULE_3___default());

      options.insert = _node_modules_style_loader_dist_runtime_insertBySelector_js__WEBPACK_IMPORTED_MODULE_2___default().bind(null, "head");
    
options.domAPI = (_node_modules_style_loader_dist_runtime_styleDomAPI_js__WEBPACK_IMPORTED_MODULE_1___default());
options.insertStyleElement = (_node_modules_style_loader_dist_runtime_insertStyleElement_js__WEBPACK_IMPORTED_MODULE_4___default());

var update = _node_modules_style_loader_dist_runtime_injectStylesIntoStyleTag_js__WEBPACK_IMPORTED_MODULE_0___default()(_node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"], options);




       /* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (_node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"] && _node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"].locals ? _node_modules_css_loader_dist_cjs_js_base_css__WEBPACK_IMPORTED_MODULE_6__["default"].locals : undefined);


/***/ })

}]);
//# sourceMappingURL=style_index_js.81f26806623e260f937d.js.map